From:             Acereda Macia Jorge <al004046@alumail.uji.es>
Subject:          Here's our entry...
To:               amycoders@ibm.net
Date sent:        Fri, 3 Jul 1998 16:50:06 +0200 (METDST)
Send reply to:    <al004046@alumail.uji.es>

Hi!

This is our entry to the particles compo. 

--->8------>8------>8------>8------>8------>8------>8------>8------>8---
**********************************************************************
* Authors: 
*   Oscar Villellas (al004221@alumail.uji.es)
*   Jorge Acereda (aka Dr. Slump / Capsule) (al004046@alumail.uji.es)
*
* Size: 68 bytes (rts included)
*
* Comment: There's only 1 68020 instruction, the scc (off.l,a0,d1.w).
* We didn't find a way to plot on 68000 without adding 2 bytes :-(
**********************************************************************

PhxAss	EQU	1
	IFNE	PhxAss
	MACHINE	68020		; Accept 020 instructions.
	OPT	0		; Turn off optimizations.
	ENDC

; Comment these if they're already defined!
SCR_WIDTH	EQU	256
SCR_HEIGHT	EQU	256

_gpart
;  IN: a0=pointer to chunky buffer (256x256x8)
;      a1=pointer to particle array {px1,py1,vx1,vy1...pxn,pyn,vxn,vyn}.w

	moveq	#0,d7		; loop counter		;2
.loop:
	movem.w	(a1)+,d0/d1	; word px, word py	;4
				; We use movem here instead 
				; of 2 moves to sign-extend 
				; automagically.
	move.l	d0,d2		; We'll need these	;2
	move.l	d1,d3		; sign-extended values 	;2
				; later.
       
        muls.w  d0,d0                                  	;2
        muls.w  d1,d1                                  	;2
        add.l   d0,d1           ; dist**2             	;2     
        spl     d1           	; Avoid division by 0. 	;2

	; You can get different gravity values playing with these.
	; Don't shift d1 by 8 :-)
        asr.l   #7,d1            	             	;2
        asl.l   #4,d2                                  	;2
        asl.l   #4,d3                                  	;2

        divs.w  d1,d2       	; px/dist**2           	;2
        divs.w  d1,d3           ; py/dist**2           	;2

        sub.w   d2,(a1)+    	; vx-=px/dist**2       	;2
        sub.w   d3,(a1)+        ; vy-=py/dist**2       	;2     
	move.l	-(a1),d0				;2
        add.l   d0,-(a1)        ; px.py+=vx.vy         	;2 

        move.w  (a1)+,d0 				;2
        move.w  (a1)+,d1                               	;2
        asl.w   #4,d0                                  	;2
        bvs.b   .clip           ; If sign changes, clip ;2
        asr.l   #8,d0                                  	;2
        asl.w   #4,d1                                  	;2
        bvs.b   .clip           ; Same here            	;2
        move.b  d0,d1                                  	;2
; This should look good with the right palette...
;	addq.b	#1,(((SCR_WIDTH*SCR_HEIGHT+SCR_WIDTH)/2).l,a0,d1.w) ;6 
; However the rules stated that each particle must be plotted in a color
; distict from 0, so just in case 256 particles share the same location...
	scc	(((SCR_WIDTH*SCR_HEIGHT+SCR_WIDTH)/2).l,a0,d1.w) ;6 

.clip:
	addq.l	#4,a1					;2
	addq.w	#8,d7					;2
	bvc.b	.loop		; d7 will overflow 	;2
				; after 4096 iterations.
				; We save 2 bytes using this
				; kludge instead of dbra
        rts                                           	;2

--->8------>8------>8------>8------>8------>8------>8------>8------>8---

Greetings,
-- 
 ---------------------------- --------------------------------------------
|       Jorge Acereda        |      Dream the same thing everynight       |
|  al004046@alumail.uji.es   |       I see our freedom in my sight        |
|       Intel Outside        |     No locked doors, no windows barred     |
|        Amiga Rules         |   No things to make my brain seem scarred  |
 ---------------------------- --------------------------------------------

