Date sent:        Mon, 15 Jun 1998 18:32:42 +0300 (EEST)
From:             Harry Sintonen <sintonen@jyu.fi>
To:               amycoders@ibm.net
Subject:          my latest entry, 74 bytes


;****************************************************************************
;**
;*       Size-optimized Gravity Particle routine
;*
;*  This is one of my contributions to #amycoders Gravity Particle-compo.
;*  This routine will participate size-optimizing competition. This code
;*  works with all 0x0 processors with any cache setup.
;*
;*  Code size without rts: 74 bytes.
;*
;*  Coded by Harry "Piru" Sintonen <sintonen@jyu.fi>.
;*  This code is copyright  1998 by Harry Sintonen, and was written 10th-
;*  15th june 1998. Permission for use as educational material granted. ;)
;*
;****************************************************************************
;*

_gpart
;  IN: a0=pointer to chunky buffer (256x256x8)
;      a1=pointer to particle array {px1,py1,vx1,vy1...pxn,pyn,vxn,vyn}.w
; OUT: d0-d6/a1 trashed

        moveq   #0,d6           ; 2
.loop   moveq   #64,d0          ; 2
        movem.w (a1),d2-d5      ; 4 fetch px,py,vx,vy
        lsl.l   #1+4,d0         ; 2
        add.w   d4,(a1)         ; 2 px+=vx
        move.w  (a1)+,d2        ; 2 get new px
        move.l  d0,d1           ; 2
        add.w   d5,(a1)         ; 2 py+=vy
        move.w  (a1)+,d3        ; 2 get new py
        sub.l   d2,d0           ; 2 xdif=128.0-px
        sub.l   d3,d1           ; 2 ydif=128.0-py
        move.l  d0,d4           ; 2
        move.l  d1,d5           ; 2
        muls.w  d0,d0           ; 2
        muls.w  d1,d1           ; 2
        add.l   d1,d0           ; 2
        lsr.l   #8,d0           ; 2
        lsr.w   #4,d0           ; 2 l=(xdif^2+ydif^2)>>12
        beq.b   .zero           ; 2 no divide by zero
        divs.w  d0,d4           ; 2 xdif/l
        divs.w  d0,d5           ; 2 ydif/l
.zero   add.w   d4,(a1)+        ; 2 vx+=xdif/l
        add.w   d5,(a1)+        ; 2 vy+=ydif/l   

        movep.w -8(a1),d0       ; 4 PxPy  
        and.w   #$F0F0,d0       ; 4 outside screen?
        bne.b   .skip           ; 2 yup, skip this particle

        ext.l   d3              ; 2 ????0ypy -> 00000ypy
        lsr.w   #4,d2           ; 2 0xpx -> 00xp 
        lsl.w   #4,d3           ; 2 00000ypy -> 0000ypy0
        move.b  d2,d3           ; 2 0000ypxp
        st      0(a0,d3.l)      ; 4 draw particle
.skip   
        addq.w  #8,d6           ; 2 32768/8 = 4096
        bpl.b   .loop           ; 2 =74

        rts


 .   _  _  __  ___  ___         __  _ _  _ ___  __  _  _ ___ _  _   ,
  )  |__| |__| |__) |__) \_/   (__' | |\ |  |  |  | |\ | |_  |\ |  (  
 (   |  | |  | |  | |  |  |    .__) | | \|  |  |__| | \| |__ | \|   ) 
  )  '  ' '  ' '  ' '  '  '         '    '             '        '  (
 (     Amiga 1200T, Blizzard 1230-III 50MHz, 34M/5.5G/20xcdrom,     )
  )      scandoubler, Salora 445G 21", 10mbit PCMCIA ethernet      (
 /  email: sintonen@st.jyu.fi    WWW: http://www.jyu.fi/~sintonen/  \


