Send reply to:    tsuikki@lut.fi
Subject:          My particle compo entry
From:             tsuikki@jt3-305.tky.hut.fi (Teemu Suikki)
Date sent:        Thu, 2 Jul 98 22:02:07 +0200
Organization:     Petsoff Limited Partnership
To:               amycoders@ibm.net

Hi, here's little something for you:

;
; Particle compo
;
; 68 byte routine by Teemu Suikki (tsuikki@lut.fi)
;
; Pseudocode program, slightly modified from original but
; identical operation:
;
;  Loop i=1...n 
;    length = px*px+py*py
;    length = length * gravity
;    vx     = vx - px / length
;    vy     = vy - py / length
;    px     = px + vx
;    py     = py + vy
;    { ... plotparticle ... }
;  loopend
;
;  IN: a0=pointer to chunky buffer (256x256x8)
;      a1=pointer to particle array {px1,py1,vx1,vy1...pxn,pyn,vxn,vyn}.w

	moveq	#0,d0		;d0=loop counter
	moveq	#0,d1
.loop
	movem.w	(a1),d2-d5	;d2=px, d3=py, d4=vx, d5=vy
	move.l	d2,d6
	move.l	d3,d7

	muls	d6,d6		;calculate length
	muls	d7,d7
	add.l	d6,d7
	divu	#$500,d7	;gravity
	ble.s	.divzero	;beq doesn't work here, ble does..

	divs	d7,d2
	divs	d7,d3
	sub.w	d2,d4		;calc new vx and vy
	sub.w	d3,d5
.divzero
	add.w	d4,(a1)		;add to px and py
	move.w	(a1)+,d2	;get px and py
	add.w	d5,(a1)
	move.w	(a1)+,d1
	move.w	d4,(a1)+	;store vx and vy
	move.w	d5,(a1)+	

	asl.w	#4,d1		;clip
	bvs.s	.clip
	asl.w	#4,d2
	bvs.s	.clip

	lsr.w	#8,d2		;plot
	move.b	d2,d1
	eor.w	#$8080,d1	;change origo to 128,128
	st.b	0(a0,d1.l)
.clip
	addq.w	#8,d0		; loop counter
	bpl.s	.loop

	rts



-- 
D,O;main(){char*X="X`>@X@@~~`#~X~~##`##> # "//  "tsuikki@lut.fi  IRC:Zuikkis"
" `>?X~#88`  XC#  ` #X##  ` ~X~~  `@@",*S="\n"  "Petsoff Limited Partnership"
;for(O=0;*++X;O++)for(D=256;D/=2;)putchar((*X^64)&D?S[O&7]&95:32);puts(S+8);}



